/* databaseProgram.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef DATABASEPROGRAM_H
#define DATABASEPROGRAM_H

// This is a base class for any Paloma program that attaches to a
// database and stuff, but doesn't necessarily have a gui and so
// doesn't need Gtk.

#include "mainProgram.h"

#include <string>
#include <vector>

class DatabaseProgram : public MainProgram {
public:
  DatabaseProgram(const string &program_name);

  virtual void command_line(int argc, char *argv[]);
  virtual void init();

protected:
  virtual void handle_opts(const string &opt, const string &arg);

  virtual void describe_options();

  class Opt {
  public:
    string _opt;
    bool _takes_arg;
  };

  typedef vector<Opt> Opts;
  Opts _opts;

  enum DBType {
    DBT_unknown,
    DBT_pgsql,
    DBT_mysql
  };
  DBType _dbtype;

  string _dbname;
  string _dbhost;
  string _dbuser;
  string _dbpasswd;
  int _dbport;
  string _program_name;
};

#endif
